*
* Hardball
*

	mx	%00
	rel
	dsk	START.L
	lst	off

*----------------------------------------------
* MACROS
*----------------------------------------------

	use	4/Locator.Macs
	use	4/Mem.Macs
	use	4/Misc.Macs
	use	4/Util.Macs

*----------------------------------------------
* EXTERNALS
*----------------------------------------------

WAVETABLE	EXT
TITLE		EXT
GAME		EXT
ptrSDATA	EXT
myDP		EXT

*----------------------------------------------
* EQUATES
*----------------------------------------------

NEWVIDEO 	EQU $E0C029
CLOCKCTL 	EQU $E0C034
SHADOW          EQU $E0C035
SOUNDCTL 	EQU $E0C03C
SOUNDDATA 	EQU $E0C03D
SOUNDADRL 	EQU $E0C03E
SOUNDADRH 	EQU $E0C03F
GSOS 		EQU $E100A8

*----------------------------------------------
* START
*----------------------------------------------

	phk
	plb
	
	tdc
	stal	myDP
	
	_TLStartUp
	
	pha
	_MMStartUp
	pla
	sta	mainID
	ora	#$0100
	sta	myID
	
	_MTStartUp

*--- Some inits

	sep	#$20
	ldal	SHADOW
	sta	saveSHADOW
	ora	#$16
	and	#$b6
	stal	SHADOW

	ldal	CLOCKCTL
	sta	saveCLOCKCTL
	and	#$F0
	stal	CLOCKCTL
	
	ldal	NEWVIDEO
	sta	saveNEWVIDEO
	and	#$01
	ora	#$c0
	stal	NEWVIDEO

*--- Show the title

	rep	#$20
	ldx	#$8000-2
]lp	ldal	TITLE,x
	stal	$012000,x
	dex
	dex
	bpl	]lp
	sep	#$20
	
*--- Move wavetable into DOCRAM

        lda	#$70	; %01110000 = autoinc
        stal	SOUNDCTL
	lda	#$00
        stal	SOUNDADRL
	stal	SOUNDADRH

	ldx	#0
]lp     ldal	WAVETABLE,x
        stal	SOUNDDATA
        inx
        bne	]lp

*--- Back in full 16-bit

	rep	#$20

	pha		; We want 192KB
	pha
	PushLong	#$030000
	PushWord	myID
	PushWord	#$C00C
	PushLong	#0
	_NewHandle
	phd
	tsc
	tcd
	lda	[$03]
	clc
	adc	#$c800	; this is where it begins!
	sta	L0313
	stal	ptrSDATA
	ldy	#2
	lda	[$03],y
	adc	#0
	sta	L0313+2
	stal	ptrSDATA+2
	pld
	pla
	sta	myHANDLE
	pla
	sta	myHANDLE+2
	bcs	QUIT

*--- Load the file
	
	jsr	loadFILE	; load SDATA, the big file
	bcs	QUIT

	jmpl	GAME		; now play
	
*----------------------------------------------
* QUIT GAME
*----------------------------------------------

QUIT	ENT

	phk
	plb

	sep	#$20
	lda	saveNEWVIDEO
	stal	NEWVIDEO
	
	lda	saveCLOCKCTL
	stal	CLOCKCTL
	
	lda	saveSHADOW
	stal	SHADOW
	rep	#$20

*--- Kill handles

	_MTShutDown
	
	PushWord myID
	_DisposeAll
	
	PushWord mainID
	_MMShutDown
	
	_TLShutDown
	
	jsl	GSOS
	dw	$0029
	adrl	proQUIT
	
	brk	$bd

*----------------------------------------------
* READ FILE
*----------------------------------------------

loadFILE	=	*

         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L0301
         BCS   L0105

         LDA   L0301
         STA   L030B
         STA   L0311
         STA   L031F

         JSL   GSOS
         DW    $0019      ; GetEOF
         ADRL  L030B
         BCS   L0105

         LDA   L030D
         STA   L0317
         LDA   L030D+2
         STA   L0317+2

         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L0311

L0105    php
	 JSL   GSOS
         DW    $0014      ; Close
         ADRL  L031F
	 plp
         RTS

*----------------------------------------------
* MY DATA
*----------------------------------------------

proQUIT	ds	4
	ds	2

mainID	ds	2
myID	ds	2
myHANDLE	ds	4

saveSHADOW	ds	1
saveCLOCKCTL	ds	1
saveNEWVIDEO	ds	1
	
L0218    STR   '1/SDATA'

L0301    DW    $0000      ;  ref num
         ADRL  L0218      ;  path name
         ADRL  $00000000  ;  reserved

L030B    DW    $0000      ;  ref num
L030D    ADRL  $00000000  ;  end of file

L0311    DW    $0000      ;  ref num
L0313    ADRL  $00000000  ;  buffer ptr
L0317    ADRL  $00000000  ;  request count
         ADRL  $00000000  ;  transfer count

L031F    DW    $0000      ;  ref num
